Attribute VB_Name = "Wrapper"
'*****************************************************************************
'* aisa47w.bas
'*
'* aISA-R47
'*
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'*
'* Date 1998/05/26
'*
'*****************************************************************************
Option Explicit

Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const AISA47_DLL_NAME = "aisa47.dll"  ' DLLt@C
Global Const AISA47_ERR_WRAPDLL = -1        ' bp[֐G[

Dim hDLL As Long                'DLLւ̃nh

'*****************************************************************************
'* @\     aisa47.dll[h
'*      Ȃ
'* ߂l   True  --- 
'*          False --- s
'*****************************************************************************
Function Aisa47wDllOpen() As Boolean

    Aisa47wDllOpen = False
    
    If hDLL <> 0 Then Exit Function
    hDLL = LoadLibrary(AISA47_DLL_NAME)
    
    If hDLL = 0 Then Exit Function
    
    If Aisa47wGetDllExportFunc() = False Then
        Aisa47wDllClose     ' DLL GNX|[g֐LmFɎŝŁADLL N[Y
        Exit Function
    End If
    
    Aisa47wDllOpen = True

End Function

'*****************************************************************************
'* @\     aisa47.dllA[h
'*      Ȃ
'* ߂l   True  --- 
'*          False --- s
'*****************************************************************************
Function Aisa47wDllClose() As Boolean
    
    If hDLL = 0 Then
        Aisa47wDllClose = True
        Exit Function
    End If
    
    If FreeLibrary(hDLL) <> 0 Then
        hDLL = 0
        Aisa47wDllClose = True
        Exit Function
    End If
    
    Aisa47wDllClose = False

End Function

'*****************************************************************************
'* @\     aISA-R47 DLL,Driver̃o[Wԍ擾
'*      pdwDllVer --- DLLo[Wԍi[
'*          pdwDrvVer --- Drivero[Wԍi[
'* ߂l   True       --- 
'*          False      --- s
'*****************************************************************************
Function Aisa47wGetVersion(pdwDllVer As Long, pdwDrvVer As Long) As Boolean
    
    If hDLL = 0 Then
        Aisa47wGetVersion = 0
        Exit Function
    End If
    
    If Aisa47GetVersion(pdwDllVer, pdwDrvVer) <> 0 Then
        Aisa47wGetVersion = True
    Else
        Aisa47wGetVersion = False
    End If

End Function

'*****************************************************************************
'* @\     aISA-R47̔Cӂ̃foCX̎gp錾
'*      pwLogSlot --- gpfoCXi[AhX
'* ߂l   True      --- 
'*          False     --- s
'*****************************************************************************
Function Aisa47wCreate(pwLogSlot As Integer) As Boolean
    
    If hDLL = 0 Then
        Aisa47wCreate = False
        Exit Function
    End If
    
    If Aisa47Create(pwLogSlot) <> 0 Then
        Aisa47wCreate = True
    Else
        Aisa47wCreate = False
    End If

End Function

'*****************************************************************************
'* @\     aISA-R47̔Cӂ̃foCX̎gpJ
'*      wLogSlot --- gpfoCX
'* ߂l   True     --- 
'*          False    --- s
'*****************************************************************************
Function Aisa47wClose(wLogSlot As Integer) As Boolean
    
    If hDLL = 0 Then
        Aisa47wClose = False
        Exit Function
    End If
    
    If Aisa47Close(wLogSlot) <> 0 Then
        Aisa47wClose = True
    Else
        Aisa47wClose = False
    End If

End Function

'*****************************************************************************
'* @\     wfoCX̃\[X擾
'*      wLogSlot --- ׂfoCX
'*          pResInfo --- \[Xi[\̂̃AhX
'* ߂l   True     --- 
'*          False    --- s
'*****************************************************************************
Function Aisa47wGetResource(wLogSlot As Integer, pResInfo As AISA47RESOURCE) As Boolean
    
    If hDLL = 0 Then
        Aisa47wGetResource = False
        Exit Function
    End If
    
    If Aisa47GetResource(wLogSlot, pResInfo) <> 0 Then
        Aisa47wGetResource = True
    Else
        Aisa47wGetResource = False
    End If

End Function

'*****************************************************************************
'* @\     Cӂ̃|[gf[^
'*      wLogSlot  --- ͂foCX
'*          dwPort    --- ͂|[g
'*          pbInValue --- ̓f[^i[
'* ߂l   True      --- 
'*          False     --- s
'*****************************************************************************
Function Aisa47wInPort(wLogSlot As Integer, dwPort As Long, pbInValue As Byte) As Boolean
    
    If hDLL = 0 Then
        Aisa47wInPort = False
        Exit Function
    End If
    
    If Aisa47InPort(wLogSlot, dwPort, pbInValue) <> 0 Then
        Aisa47wInPort = True
    Else
        Aisa47wInPort = False
    End If

End Function

'*****************************************************************************
'* @\     Cӂ̃|[gփf[^o
'*      wLogSlot  --- o͂foCX
'*          dwPort    --- o͂|[g
'*          bOutValue --- o͂f[^
'* ߂l   True      --- 
'*          False     --- s
'*****************************************************************************
Function Aisa47wOutPort(wLogSlot As Integer, dwPort As Long, bOutValue As Byte) As Boolean
    
    If hDLL = 0 Then
        Aisa47wOutPort = False
        Exit Function
    End If
    
    If Aisa47OutPort(wLogSlot, dwPort, bOutValue) <> 0 Then
        Aisa47wOutPort = True
    Else
        Aisa47wOutPort = False
    End If

End Function

'*****************************************************************************
'* @\      aISA-R47̃G[R[h𓾂
'*       wLogSlot --- G[foCX
'* ߂l             --- G[R[h
'*****************************************************************************
Function Aisa47wGetLastError(wLogSlot As Integer) As Long
    
    If hDLL = 0 Then
        Aisa47wGetLastError = AISA47_ERR_WRAPDLL
        Exit Function
    End If
    
    Aisa47wGetLastError = Aisa47GetLastError(wLogSlot)

End Function

'*****************************************************************************
'* @\     DLLGNX|[g֐L̊mF
'*      Ȃ
'* ߂l   True  --- 
'*          False --- s
'*****************************************************************************
Private Function Aisa47wGetDllExportFunc() As Boolean
    
    Dim pFunc As Long
    
    Aisa47wGetDllExportFunc = False
    
    ' Aisa47GetVersion ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa47GetVersion")
    If pFunc = 0 Then Exit Function
          
    ' Aisa47Create ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa47Create")
    If pFunc = 0 Then Exit Function
          
    ' Aisa47Close ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa47Close")
    If pFunc = 0 Then Exit Function

    ' Aisa47GetResource ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa47GetResource")
    If pFunc = 0 Then Exit Function

    ' Aisa47InPort ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa47InPort")
    If pFunc = 0 Then Exit Function

    ' Aisa47OutPort ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa47OutPort")
    If pFunc = 0 Then Exit Function

    ' Aisa47GetLastError ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa47GetLastError")
    If pFunc = 0 Then Exit Function

    Aisa47wGetDllExportFunc = True  ' SĂ DLL GNX|[g֐݂̑mF

End Function
